﻿
'ssrOS1 VB v1.0   2011/03/07

'ADunit　コミニケーション仕様
' COMポート　19200bps　

'A/Dからのデータ
'   PCからSTコマンドが来た後　ADデータを送る。　　## ２文字のHexを１データとし、ひとかたまりの終わりをCrLf
'　　A/Dからのコマンドは　External　Trigger　だけ　　　ETとする

' PCからの設定コマンド    ADunit側で受付可能かが分らないので、設定変更時処理は　Stop/Start　と同じとする。
' コマンドは　　**Cr　の３文字    全てエコーバックを待つ
'-------------
'Tscale		時間設定	サンプリング	画面
'
'	T1			0.5mS/div	0.05mS	 ５０ポイント
'	T2			1mS			0.05mS	１００
'	T3			5			0.1mS	２５０　　　　
'	T4			10			0.2mS	２５０　
'	T5			50			1mS		２５０
'	T6			100			2mS		２５０
'	T7			500			10mS	２５０　--ここからADunitはリアルタイム送信       　　
'	T8			1000		10mS	５００ポイント/画面
'	T9			<<Sec		10mS	Sec倍でT軸をひとつ進める

'キャリブレーション　　Zero点と基準電圧の値は　PC側　ファイル内に格納  　
'　ZZ　　Zero点　測定開始　　　　　Zero点をEEPROMに格納
'　ZR	基準点測定　　　基準点をEEPROMに格納	
'  ZQ Zero点、 応答 データ　####Cr
'  ZK 基準電圧点データ要求　   応答 データ　####Cr　 

'Trigger   　r
'	GE:Externa G0：フリーラン　　　　              
'	G1からG9：10%～90%
'	N1からN9：-10%～-90%
'	UP、DN   : 方向
'レンジ
'	R0,R1,R2:Range 0.2,　2,　20 V/F 
'Vシフト
'	V1,V2,V4　　1/1,　1/2,　1/4　
'開始
'	ST  
'終了
'	PU     P送信後　エコーバックを待つ

'Display　仕様
'　波形表示画面　５００（ｔ）＊４００（ｖ）　　中点：200　１Div(t)=100　１Div(v)=100
'                

'
'　時間割り込み1　設定５０ｍS　　処理時間 ＋割り込み最大時間＝　50μS*4096＝203ｍS　　　


Public Class Form1

    Dim Measure As Integer
    Dim Vshift As String
    Dim Vscale As Single

    Dim Tscale As String
    Dim TpointInc As Single  '　ｔ軸の１ADデータの増分　小数点あり
    Dim Tpoint As Single '  画面のｔポイント　0-500　小数点あり
    Dim Tunit As Single ' サンプリング時間

    Dim TriggerL As Integer
    Dim TriggerDir As String ' Up or Down
    Dim Triggered As Integer   ' 0:初期状態　1:レベルを超える前のレベル　2:トリガー開始

    Dim RdChr(3) As Char
    Dim AD(500) As Integer 'AD unit からの生データとする--　128を中心に　0-255
    Dim TestF As Integer = 0
    Dim MaxF As Integer = 0
    Dim MaxPoint As Integer

    Dim Zero As Integer
    Dim Kfactor As Single  ' A/D データの補正係数　　真値＝（A/DデーターZeor点）＊K   100/Full slace



    Dim iAD As Integer 'AD 500点の格納


    Private Sub ScaleDraw()
        Dim gD As Graphics = PictureBoxD.CreateGraphics()
        gD.FillRectangle(Brushes.Ivory, 0, 0, 500, 400)


        Dim p As New Pen(Color.Blue, 1)
        For x = 0 To 5
            gD.DrawLine(p, x * 100, 0, x * 100, 400)
        Next x
        For y = 0 To 4
            gD.DrawLine(p, 0, y * 100, 500, y * 100)
        Next y
        If MaxF > 0 And MaxPoint > 0 Then gD.DrawLine(Pens.Green, 0, 200 - 2 * MaxPoint, 500, 200 - 2 * MaxPoint)

    End Sub

    ' RdChr(0) & RdChr(1)の16進表記文字列を10進数に変換　&H0～＆HF以外の数値は256とする。
    Private Function RecNum() As Integer
        Dim num16 As Integer
        If ((RdChr(0) > "/" And RdChr(0) < ":") Or (RdChr(0) > "@" And RdChr(0) < "G")) And _
           ((RdChr(1) > "/" And RdChr(1) < ":") Or (RdChr(1) > "@" And RdChr(1) < "G")) Then

            Dim a As String = RdChr(0) & RdChr(1)
            Dim b As String = "&H" + Mid(a, 1, 2)
            num16 = CInt(b)
        Else
            num16 = 256
        End If
        Return num16
    End Function


    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim AD0 As Integer
        Dim AD1 As Integer

        Dim gD As Graphics = PictureBoxD.CreateGraphics()
        Timer1.Enabled = False
Repeat:
        If SerialPort.BytesToRead < 2 Then GoTo Abort1
        SerialPort.Read(RdChr, 0, 2)

        If RdChr(0) = ControlChars.Cr And RdChr(1) = ControlChars.Lf Then GoTo Repeat ' データの区切り

        If RdChr(0) = "E" Then  '---ADunit からのExternal　Trigger
            Triggered = 2
            GoTo Repeat
        End If


        If Tpoint = 0 Then ScaleDraw()

        AD(iAD) = RecNum()
        If AD(iAD) = 256 Then '  Error
            ButtonStart.ForeColor = Color.Red
            ButtonStart.Text = "Error"
            GoTo Abort2
        End If
        If Triggered = 2 Then GoTo SkipT
        If Tscale > "6" And ComboBoxTrigger.Text <> "0" And CheckBoxEXT.Checked = "False" Then ' トリガ処理が必要(T7以上)
            If TriggerDir = "Up" Then
                If Triggered = 0 Then
                    If AD(iAD) > 128 + TriggerL * 10 Then
                        GoTo Repeat
                    Else
                        Triggered = 1
                        GoTo Repeat
                    End If
                Else '  Triggered = 1
                    If AD(iAD) <= 128 + TriggerL * 10 Then GoTo Repeat
                    Triggered = 2
                End If
            Else '  Down
                If Triggered = 0 Then
                    If AD(iAD) < 128 + TriggerL * 10 Then
                        GoTo Repeat
                    Else
                        Triggered = 1
                        GoTo Repeat
                    End If
                Else '  Triggered = 1
                    If AD(iAD) >= 128 + TriggerL * 10 Then GoTo Repeat
                    Triggered = 2
                End If
            End If
        End If

SkipT:
        Dim k2 As Integer = CInt(Tpoint)
        Dim k1 As Integer = CInt(Tpoint - TpointInc)
        If k1 = k2 Then k1 = k1 - 1
        If k1 > 0 And k2 < 501 Then
            AD0 = AD(k1)
            AD1 = AD(k2)
            If Vshift = "2" Then
                AD0 = AD0 * 2
                AD1 = AD1 * 2
            End If
            If Vshift = "1" Then
                AD0 = AD0 * 4
                AD1 = AD1 * 4
            End If
            AD0 = CInt(CSng(AD0 - Zero) * Kfactor)
            AD1 = CInt(CSng(AD1 - Zero) * Kfactor)
            If Vshift = "2" Then
                AD0 = AD0 / 2
                AD1 = AD1 / 2
            End If
            If Vshift = "1" Then
                AD0 = AD0 / 4
                AD1 = AD1 / 4
            End If

            If AD0 > 100 Then AD0 = 100
            If AD0 < -100 Then AD0 = -100
            If AD1 > 100 Then AD1 = 100
            If AD1 < -100 Then AD1 = -100
            gD.DrawLine(Pens.Red, k1, 200 - 2 * AD0, k2, 200 - 2 * AD1)
            TextBoxLevel.Text = CStr(CSng(AD1) * Vscale / 100)
        End If
        If MaxF > 0 And MaxPoint < AD1 Then
            MaxPoint = AD1
            gD.DrawLine(Pens.Green, 0, 200 - 2 * MaxPoint, 500, 200 - 2 * MaxPoint)
        End If
        Tpoint = Tpoint + TpointInc
        iAD = CInt(Tpoint)

        If Tpoint = 500 Then '-----1画面終了処理
            Tpoint = 0
            iAD = 0
            Triggered = 0
            If ComboBoxMode.Text = "One Shot" Or ComboBoxMode.Text = "One Shot & Save" Then
                Pause()
                Measure = 0
                If ComboBoxMode.Text = "One Shot & Save" Then SaveData()
                GoTo Abort2
            End If

        End If
        GoTo Repeat

Abort1:
        Timer1.Enabled = Enabled
Abort2:
    End Sub
    Private Sub SaveData()
        '----ファイルセーブ　　デスクトップ　Data_Ocillo.csv 
        '日時,V単位（V）,時間単位(mSec），データ個数,*,*,----データ
        Dim dd As Date = Date.Now
        Dim d As String = dd.ToString("g")
        Dim v As String = CStr(Vscale / 100)
        Dim t As String = CStr(Tunit)
        Dim N As String = "500"
        Dim Vdata As Integer
        If TpointInc > 2 Then N = CStr(500 / TpointInc)

        Dim Dir As String = System.Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory)
        Try
            Using F_Oci = New IO.StreamWriter(Dir + "\Data_Ocillo.csv", False, System.Text.Encoding.Default)
                F_Oci.WriteLine(d)
                F_Oci.WriteLine(v)
                F_Oci.WriteLine(t)
                F_Oci.WriteLine(N)
                Dim k As Integer = CInt(N) - 1
                For i = 0 To k
                    Vdata = AD(i)
                    If Vshift = "2" Then Vdata = Vdata * 2
                    If Vshift = "1" Then Vdata = Vdata * 4
                    Vdata = CInt(CSng(Vdata - Zero) * Kfactor)
                    If Vshift = "2" Then Vdata = Vdata / 2
                    If Vshift = "1" Then Vdata = Vdata / 4
                    F_Oci.WriteLine(CStr(Vdata))
                Next i
            End Using
        Catch ex As Exception
            ToolTip1.Show(ex.Message, Me, 100, 44, 300000)
        End Try

    End Sub

    Private Sub ComboBoxTscale_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxTscale.SelectedIndexChanged
        If ComboBoxTscale.Text <> "<<Sec" Then TextBoxTime.Text = ""
        If Measure = 1 And TextBoxTime.Text <> "" Then
            Pause()
            Start()
        End If
    End Sub

    Private Sub ComboBoxCOM_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxCOM.SelectedIndexChanged

    End Sub

    Private Sub Command(ByVal a As String)  'aは2文字　　　エコーバックを待つ
        Dim c1(1) As Char
        Dim c2(1) As Char
        Dim c3(1) As Char

        SerialPort.Write(Mid(a, 1, 1))
        While SerialPort.BytesToRead < 1
        End While
        SerialPort.Read(c1, 0, 1)

        SerialPort.Write(Mid(a, 2, 1))
        While SerialPort.BytesToRead < 1
        End While
        SerialPort.Read(c2, 0, 1)

        SerialPort.Write(ControlChars.Cr)
        While SerialPort.BytesToRead < 1
        End While
        SerialPort.Read(c3, 0, 1)
    End Sub

    Private Sub TimeSet()


        '　　   　　Tscale　　       　サンプリング周期　　　画面

        '　時間軸（)　T1　　　0.5mS/div　　　0.05mS　　　　  ５０ポイント
        '   　        T2        1mS     　　 0.05mS　　　　１００
        '             T3        5    　 　　 0.1mS　　　　 ２５０　　　　
        '             T4       10       　   0.2mS　　　 　２５０
        '　　　　　　 T5　　　 50  　　 　　 1mS　　　　 　２５０
        '             T6      100            2mS 　　　　　２５０
        '             T7      500           10mS  　　　　 ２５０　--ここからADunitはリアルタイム送信       　　
        '　　　　 　　T8　　 1000           10mS   　      ５００ポイント/画面
        '　　　　　　 T9　　 <<Sec          10mS      Sec倍でT軸をひとつ進める
        '   
        TpointInc = 2

        Select Case ComboBoxTscale.Text
            Case "0.5"
                Tscale = "1"
                TpointInc = 10
                Tunit = 0.05
            Case "1"
                Tscale = "2"
                TpointInc = 5
                Tunit = 0.05
            Case "5"
                Tscale = "3"
                Tunit = 0.1
            Case "10"
                Tscale = "4"
                Tunit = 0.2
            Case "50"
                Tscale = "5"
                Tunit = 1
            Case "100"
                Tscale = "6"
                Tunit = 2
            Case "500"
                Tscale = "7"
                Tunit = 10
            Case "1000"
                Tscale = "8"
                TpointInc = 1
                Tunit = 10
            Case "<<Sec"
                Tscale = "9"
                If TextBoxTime.Text <> "" Then TpointInc = 1 / CSng(TextBoxTime.Text)
                Tunit = 10 / TpointInc
        End Select

    End Sub
    Private Sub Start()


        SerialPort.PortName = ComboBoxCOM.Text
        SerialPort.DtrEnable = True
        SerialPort.RtsEnable = True
        SerialPort.Open()

        TimeSet()
        Command("T" & Tscale)
        If CheckBoxEXT.Text = "Extarnal" Then
            Command("GE")
        Else
            TriggerL = CInt(ComboBoxTrigger.Text) / 10
            If TriggerL >= 0 Then
                Command("G" & CStr(TriggerL))
            Else
                Command("N" & Mid(CStr(TriggerL), 2, 1))
            End If

        End If
        If RadioButtonUp.Checked = "True" Then
            Command("UP")
            TriggerDir = "Up"
        End If
        If RadioButtonDown.Checked = "True" Then
            Command("DN")
            TriggerDir = "Down"
        End If

        Dim r As String = "0"
        If Vscale > 0.2 Then r = "1"
        If Vscale > 2 Then r = "2"
        Command("R" & r)

        Vshift = "1"
        If Vscale = 0.1 Or Vscale = 1 Or Vscale = 10 Then Vshift = "2"
        If Vscale = 0.05 Or Vscale = 0.5 Or Vscale = 5 Then Vshift = "4"
        Command("V" & Vshift)

        Command("ZQ")
        Do While SerialPort.BytesToRead < 2
        Loop
        SerialPort.Read(RdChr, 0, 2)
        Zero = RecNum()
        Do While SerialPort.BytesToRead < 3
        Loop
        SerialPort.Read(RdChr, 0, 3)
        Zero = Zero * 4 + RecNum() / 64

        Command("ZK")
        Do While SerialPort.BytesToRead < 2
        Loop
        SerialPort.Read(RdChr, 0, 2)
        Dim vr As Integer = RecNum()
        Do While SerialPort.BytesToRead < 3
        Loop
        SerialPort.Read(RdChr, 0, 3)
        vr = vr * 4 + RecNum() / 64
        Kfactor = 1.84 * 50 * (CSng(vr - Zero))

        TextBox1.Text = "Zero=" & CStr(Zero - 512) & "Vref=" & CStr(vr - 512)

        Command("ST")

        ScaleDraw()
        ButtonStart.ForeColor = Color.Red
        ButtonStart.Text = "Measure"
        MaxPoint = 0
        Timer1.Enabled = Enabled

    End Sub
    Private Sub ButtonStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonStart.Click
        If Measure = 0 Then
            Start()
            Measure = 1
        End If
        TextBox1.Text = ""


    End Sub


    Private Sub Pause()

        Timer1.Enabled = False

        SerialPort.Write("P")  '-----Pを送信し、エコーを待つ
Repeat:

        While SerialPort.BytesToRead < 1
        End While
        SerialPort.Read(RdChr, 0, 1)
        If RdChr(0) <> "P" Then GoTo Repeat
        SerialPort.Write("U")
        While SerialPort.BytesToRead < 1
        End While
        SerialPort.Read(RdChr, 0, 1)
        SerialPort.Write(ControlChars.Cr)
        While SerialPort.BytesToRead < 1
        End While
        SerialPort.Read(RdChr, 0, 1)


        ButtonStart.ForeColor = Color.Black
        ButtonStart.Text = "Start"
        Tpoint = 0
        SerialPort.Close()

    End Sub



    Private Sub ButtonStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonStop.Click
        If Measure = 1 Then Pause()
        Measure = 0
        TestF = 0

    End Sub


    Private Sub PictureBoxD_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBoxD.Click
        Dim p As Point = PointToClient(System.Windows.Forms.Cursor.Position)
        Dim g As Graphics = PictureBoxD.CreateGraphics()

        Dim x As Integer = p.X.ToString()
        x = x - 106
        Dim y As Integer = p.Y.ToString()
        y = y - 144

        Dim V As Single = (200 - CSng(y)) / 200 * Vscale

        Dim DspXY As String = " " & CStr(V) & "V"
        'フォントオブジェクトの作成
        Dim fnt As New Font("MS UI Gothic", 10)
        '文字列を位置(0,0)、青色で表示
        g.DrawString(DspXY, fnt, Brushes.Green, x, y)
        g.DrawLine(Pens.Green, x - 2, y, x + 2, y)
        'リソースを開放する
        fnt.Dispose()
        g.Dispose()



    End Sub


    Private Sub ButtonMax_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMax.Click
        MaxPoint = 0
        If MaxF = 1 Then
            MaxF = 0
            ButtonMax.Text = "Set"
        Else
            ButtonMax.Text = "Clear"
            MaxF = 1
        End If

    End Sub

    Private Sub CheckBoxFile_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)


    End Sub

    Private Sub ComboBoxMode_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxMode.SelectedIndexChanged

    End Sub

    Private Sub ComboBoxTrigger_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxTrigger.SelectedIndexChanged
        If Measure = 1 And Tscale < "7" Then
            Pause()
            Start()
        End If
    End Sub

    Private Sub CheckBoxEXT_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxEXT.CheckedChanged
        If Measure = 1 Then
            Pause()
            Start()
        End If
    End Sub

    Private Sub TextBoxTime_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxTime.TextChanged
        TimeSet()
        If Tscale > 6 And Measure = 1 Then
            Pause()
            Start()
        End If
    End Sub

    Private Sub ButtonZero_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonZero.Click

        If Measure = 0 Then
            SerialPort.PortName = ComboBoxCOM.Text
            SerialPort.DtrEnable = True
            SerialPort.RtsEnable = True
            SerialPort.Open()
            If MsgBox("Set Range 2V And Short-circuit Input.  Ready ?", 1) = 1 Then Command("ZS")
            SerialPort.Close()
        End If
    End Sub

    Private Sub TextBoxLevel_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxLevel.TextChanged

    End Sub


    Private Sub TextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox1.TextChanged

    End Sub

    Private Sub RadioButtonUp_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonUp.CheckedChanged

    End Sub

    Private Sub RadioButtonDown_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonDown.CheckedChanged

    End Sub


    Private Sub ComboBoxRange_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxRange.SelectedIndexChanged

        Vscale = CSng(ComboBoxRange.Text)

        If Measure = 1 Then
            Pause()
            Start()
        End If

    End Sub

    Private Sub CheckBoxP10_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxP10.CheckedChanged

    End Sub

    Private Sub Vref_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonVref.Click
        If Measure = 0 Then
            SerialPort.PortName = ComboBoxCOM.Text
            SerialPort.DtrEnable = True
            SerialPort.RtsEnable = True
            SerialPort.Open()
            If MsgBox("Set Range 2V And Input Standard Voltage.  Ready ?", 1) = 1 Then Command("ZR")
            SerialPort.Close()
        End If
    End Sub

    Private Sub Label11_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label11.Click

    End Sub

    Private Sub SystemEvents_PowerModeChanged(ByVal sender As Object, ByVal e As Microsoft.Win32.PowerModeChangedEventArgs)
        Select Case e.Mode
            Case Microsoft.Win32.PowerModes.Suspend
                If Measure = 1 Then Pause()
                Measure = 0
            Case Microsoft.Win32.PowerModes.Resume
                If Measure = 1 Then Pause()
                Measure = 0
                TextBox1.Text = "Resume"
        End Select
    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load

        If MsgBox("Load Privious Setting ?", 1) = 1 Then
            Dim Dir As String = System.Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory)
            Try
                Using F_Oci = New IO.StreamReader(Dir + "\Set_Ocillo.txt", System.Text.Encoding.Default)

                    ComboBoxCOM.Text = F_Oci.ReadLine()
                    ComboBoxMode.Text = F_Oci.ReadLine()
                    ComboBoxTscale.Text = F_Oci.ReadLine()
                    TextBoxTime.Text = F_Oci.ReadLine()
                    RadioButtonUp.Checked = F_Oci.ReadLine()
                    RadioButtonDown.Checked = F_Oci.ReadLine()
                    ComboBoxTrigger.Text = F_Oci.ReadLine()
                    CheckBoxEXT.Checked = F_Oci.ReadLine()
                    CheckBoxP10.Checked = F_Oci.ReadLine()
                    ComboBoxRange.Text = F_Oci.ReadLine()
                End Using
            Catch ex As Exception
                ToolTip1.Show(ex.Message, Me, 100, 44, 300000)

            End Try
        End If

    End Sub



    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        If MsgBox("Save Setting ?", 1) = 1 Then
            Dim Dir As String = System.Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory)
            Try
                Using F_Oci = New IO.StreamWriter(Dir + "\Set_Ocillo.txt", False, System.Text.Encoding.Default)

                    F_Oci.WriteLine(ComboBoxCOM.Text)
                    F_Oci.WriteLine(ComboBoxMode.Text)
                    F_Oci.WriteLine(ComboBoxTscale.Text)
                    F_Oci.WriteLine(TextBoxTime.Text)
                    F_Oci.WriteLine(RadioButtonUp.Checked)
                    F_Oci.WriteLine(RadioButtonDown.Checked)
                    F_Oci.WriteLine(ComboBoxTrigger.Text)
                    F_Oci.WriteLine(CheckBoxEXT.Checked)
                    F_Oci.WriteLine(CheckBoxP10.Checked)
                    F_Oci.WriteLine(ComboBoxRange.Text)
                End Using
            Catch ex As Exception
                ToolTip1.Show(ex.Message, Me, 100, 44, 300000)

            End Try
        End If
    End Sub


End Class



