﻿Imports System.IO


'ssrOS1 VB p1.00   2011/08/03


'ADunit　コミニケーション仕様
' COMポート　19200bps　

'A/Dからのデータ
'   ## ２文字のHexを１データとし、ひとかたまりの終わりをCrLf
'　　A/Dからのコマンドは　External　Trigger　だけ　　　XTとする

' PCからの設定コマンド    ADunit側で受付可能かが分らないので、設定変更時処理は　Stop/Start　と同じとする。
' コマンドは　　**Lf　の３文字    全てエコーバックを待つ
'-------------
'Version 要求　MM　応答　####Lf　　--- ##.#

'Tscale		時間設定	サンプリング	画面
'
'	T1			0.5mS/div	0.025mS	１００ポイント＋１
'	T2			1mS			0.05mS	１６６
'	T3			5			0.1mS	２５０　　　　
'	T4			10			0.2mS	２５０　
'	T5			50			1mS		２５０
'	T6			100			2mS		２５０
'	T7			500			10mS	２５０　--ここからADunitはリアルタイム送信       　　
'	T8			1000		10mS	５００　
'	T9			<<Sec		10mS	Sec倍でT軸をひとつ進める、ADは平均化

'電圧値要求　　　
'　QQ　　測定開始　　　　応答 データ　####Lf　　

'Trigger   　
'	GE:Externa G0：フリーラン　　　　              
'	G1からG9：10%～90%
'	N1からN9：-10%～-90%
'	UP、DN   : 方向
'レンジ
'	R0,R1,R2:Range 0.2,　2,　20 V/F 
'Vシフト
'	V1,V2,V4　　1/1,　1/2,　1/4　
'開始
'	ST  
'終了
'	PU     P送信後　エコーバックを待つ

'Display　仕様
'　波形表示画面　５００（ｔ）＊４００（ｖ）　　中点：200　１Div(t)=100　１Div(v)=100
'                

'
'　時間割り込み1　設定1０ｍS　　　

Public Class Form1

    Dim Version As String = "p1.00"
    Dim Uversion As String  ' ADunit Version

    Dim Measure As Integer
    Dim Vshift As String
    Dim Vscale As Single

    Dim Tscale As String
    Dim TpointInc As Integer ' 時間軸スキップコマ
    Dim AccCnt As Integer ' 平均回数
    Dim AccCntB As Integer
    Dim iAD As Integer 'AD 501点の格納
    Dim Tunit As Single ' サンプリング時間

    Dim TriggerL As Integer
    Dim TriggerDir As String ' Up or Down
    Dim Triggered As Integer   ' 0:初期状態　1:レベルを超える前のレベル　2:トリガー開始

    Dim RdChr(6) As Char
    Dim AD(501) As Integer 'AD unit からの生データとする
    Dim AccAD As Single
    Dim TestF As Integer = 0
    Dim MaxF As Integer = 0
    Dim MaxPoint As Integer
    Dim MinPoint As Integer

    Dim Zero As Integer
    Dim ZeroR0 As String ' レンジ０の　Zero点　--ファイルに格納 10進数変換後
    Dim ZeroR1 As String
    Dim ZeroR2 As String

    Dim Vref As String ' 基準電圧点　--ファイルに格納 10進数変換後
    Dim Kfactor As Single  ' A/D データの補正係数　　真値＝（A/DデーターZeor点）＊K   100/Full slace

    Dim SetDir As String = "" ' 設定ファイルのフォルダ
    Dim DataDir As String = "" '　波形データファイルのフォルダ
    Dim DataFile As String
    Dim DataNo As String = "1"
    Dim DataNoB As Integer = 0
    Dim CurrentF As String

    Dim sw As New System.Diagnostics.Stopwatch()

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load

        Dim SetPara As String = Application.UserAppDataPath + "Set_Ocillo.ini"

        If My.Computer.FileSystem.FileExists(SetPara) Then

            Try
                Using F_Oci = New IO.StreamReader(SetPara, System.Text.Encoding.Default)

                    ComboBoxPort.Text = F_Oci.ReadLine()
                    ComboBoxMode.Text = F_Oci.ReadLine()
                    ComboBoxTscale.Text = F_Oci.ReadLine()
                    TextBoxTime.Text = F_Oci.ReadLine()
                    RadioButtonUp.Checked = F_Oci.ReadLine()
                    RadioButtonDown.Checked = F_Oci.ReadLine()
                    ComboBoxTrigger.Text = F_Oci.ReadLine()
                    CheckBoxEXT.Checked = F_Oci.ReadLine()
                    ComboBoxRange.Text = F_Oci.ReadLine()
                    DataDir = F_Oci.ReadLine()
                    DataFile = F_Oci.ReadLine()
                    DataNo = F_Oci.ReadLine()
                    ZeroR0 = F_Oci.ReadLine()
                    ZeroR1 = F_Oci.ReadLine()
                    ZeroR2 = F_Oci.ReadLine()
                    Vref = F_Oci.ReadLine()
                End Using
            Catch ex As Exception
                ToolTip1.Show(ex.Message, Me, 100, 44, 300000)

            End Try
        Else
            MsgBox("ssrOs1を始めてお使いになりますので、必ずHelpを参照し測定の前には校正（Calibration)を行ってください。")
        End If
    End Sub


    Private Sub ComboBoxCOM_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub ButtonStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonStart.Click

        If Vref = "" Or ZeroR1 = "" Then
            MsgBox("Need calibration in Set menu")
            GoTo Abort

        End If

        If Measure = 0 Then
            Start()
            Measure = 1
        End If
        TextBox1.Text = ""

Abort:
    End Sub
    Protected Overrides Function ProcessCmdKey(ByRef msg As System.Windows.Forms.Message, ByVal keyData As System.Windows.Forms.Keys) As Boolean
        ' F9 をStart ショートカットキーとして処理する

        If keyData = ConsoleKey.F9 Then
            If Vref = "" Or ZeroR1 = "" Then
                MsgBox("Need calibration in Set menu")
                GoTo Abort
            End If
            If Measure = 0 Then
                Start()
                Measure = 1
            End If
            TextBox1.Text = ""
        End If
Abort:
    End Function




    Private Sub ButtonStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonStop.Click
        If Measure = 1 Then Pause()
        Measure = 0
        TestF = 0

    End Sub

    Private Sub Start()

        SerialPort.PortName = ComboBoxPort.Text
        SerialPort.DtrEnable = True
        SerialPort.RtsEnable = True
        SerialPort.Open()

        TimeSet()
        Command("T" & Tscale)
        If CheckBoxEXT.Checked = True Then
            Command("GE")
        Else
            TriggerL = CInt(ComboBoxTrigger.Text) / 10
            If TriggerL >= 0 Then
                Command("G" & CStr(TriggerL))
            Else
                Command("N" & Mid(CStr(TriggerL), 2, 1))
            End If

        End If
        If RadioButtonUp.Checked = True Then
            Command("UP")
            TriggerDir = "Up"
        End If
        If RadioButtonDown.Checked = True Then
            Command("DN")
            TriggerDir = "Down"
        End If

        Triggered = 0

        Dim r As String = "0"
        If Vscale > 0.3 Then r = "1"
        If Vscale > 3 Then r = "2"
        Command("R" & r)

        Vshift = "1"
        If CInt(Vscale * 10) = 1 Or CInt(Vscale) = 1 Or CInt(Vscale) = 10 Then Vshift = "2"
        If CInt(Vscale * 100) = 5 Or CInt(Vscale * 10) = 5 Or CInt(Vscale) = 5 Then Vshift = "4"
        Command("V" & Vshift)


        Kfactor = 1.85 / (CSng(Vref) - CSng(ZeroR1))  '---v/count 
        Zero = CInt(ZeroR1)
        If Vscale < 0.3 Then Zero = CInt(ZeroR0)
        If Vscale > 3 Then Zero = CInt(ZeroR2)

        Command("ST")

        ScaleDraw3()
        ButtonStart.ForeColor = Color.Red
        ButtonStart.Text = "Measure"

        If MaxF = 1 Then
            MaxF = 0
            ButtonMax.Text = "Set"
        End If
        MaxPoint = -100
        MinPoint = 100

        Timer1.Enabled = Enabled
        iAD = 0
        AccCntB = AccCnt
        If Tscale = "7" Then ' 最初のデータをノイズとして捨てる
            While SerialPort.BytesToRead < 2
            End While
            SerialPort.Read(RdChr, 0, 2)
        End If
Abort:
    End Sub

    Private Sub Pause()

        Timer1.Enabled = False

        SerialPort.Write("P")  '-----Pを送信し、エコーを待つ
Repeat:

        While SerialPort.BytesToRead < 1
        End While
        SerialPort.Read(RdChr, 0, 1)
        If RdChr(0) <> "P" Then GoTo Repeat
        SerialPort.Write("U")
        While SerialPort.BytesToRead < 1
        End While
        SerialPort.Read(RdChr, 0, 1)
        SerialPort.Write(ControlChars.Lf)
        While SerialPort.BytesToRead < 1
        End While
        SerialPort.Read(RdChr, 0, 1)


        ButtonStart.ForeColor = Color.Black
        ButtonStart.Text = "Start(F9)"
        SerialPort.Close()
    End Sub

    ' RdChr(0) & RdChr(1)の16進表記文字列を10進数に変換　&H0～＆HF以外の数値は256とする。
    Private Function RecNum() As Integer
        Dim num16 As Integer
        If ((RdChr(0) > "/" And RdChr(0) < ":") Or (RdChr(0) > "@" And RdChr(0) < "G")) And _
           ((RdChr(1) > "/" And RdChr(1) < ":") Or (RdChr(1) > "@" And RdChr(1) < "G")) Then

            Dim a As String = RdChr(0) & RdChr(1)
            Dim b As String = "&H" + Mid(a, 1, 2)
            num16 = CInt(b)
        Else
            num16 = 256
        End If
        Return num16
    End Function

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim AD0 As Integer
        Dim AD1 As Integer


        Dim gD As Graphics = PictureBoxD.CreateGraphics()

        Timer1.Enabled = False
Repeat:
        If SerialPort.BytesToRead < 2 Then GoTo Abort1
        SerialPort.Read(RdChr, 0, 2)

        If RdChr(0) = "X" Then  '---ADunit からのExternal　Trigger
            Triggered = 2
            GoTo Repeat
        End If


        AD0 = RecNum()
        If AD0 = 256 Then '  Error
            ButtonStart.ForeColor = Color.Red
            ButtonStart.Text = "Error"
            GoTo Abort2
        End If

        If TpointInc >= 1 Then ' 2sec　以上は平均化する
            AD(iAD) = AD0
        Else
            AccAD = AccAD + CSng(AD0)
            AccCntB = AccCntB - 1
            If AccCntB = 0 Then
                AD(iAD) = CInt(AccAD / CSng(AccCnt))
                AccAD = 0
                AccCntB = AccCnt
            Else
                GoTo Repeat
            End If
        End If

        If Triggered = 2 Then GoTo SkipT

        If Tscale > "6" Then
            If CheckBoxEXT.Checked = True Then GoTo Repeat
            If ComboBoxTrigger.Text <> "0" Then ' トリガ処理が必要(T7以上)
                If TriggerDir = "Up" Then
                    If Triggered = 0 Then
                        If AD(iAD) > 128 + TriggerL * 10 Then
                            GoTo Repeat
                        Else
                            Triggered = 1
                            GoTo Repeat
                        End If
                    Else '  Triggered = 1
                        If AD(iAD) <= 128 + TriggerL * 10 Then GoTo Repeat
                        Triggered = 2
                    End If
                Else '  Down
                    If Triggered = 0 Then
                        If AD(iAD) < 128 + TriggerL * 10 Then
                            GoTo Repeat
                        Else
                            Triggered = 1
                            GoTo Repeat
                        End If
                    Else '  Triggered = 1
                        If AD(iAD) >= 128 + TriggerL * 10 Then GoTo Repeat
                        Triggered = 2
                    End If
                End If
            End If

        End If



SkipT:
        If iAD = 0 And AccCntB = AccCnt Then ScaleDraw()
        Dim kAD As Integer = iAD - TpointInc
        If kAD = iAD Then kAD = iAD - 1
        If iAD > 0 And iAD < 501 Then

            AD0 = AD(kAD)
            AD1 = AD(iAD)

            Select Case Vshift
                Case "4"
                    AD0 = CInt(CSng(AD0 + 384 - Zero) * Kfactor * 200.0 + 0.5)
                    AD1 = CInt(CSng(AD1 + 384 - Zero) * Kfactor * 200.0 + 0.5)

                Case "2"
                    AD0 = CInt(CSng(AD0 + 128 - Zero / 2) * Kfactor * 200.0 + 0.5)
                    AD1 = CInt(CSng(AD1 + 128 - Zero / 2) * Kfactor * 200.0 + 0.5)

                Case "1"
                    AD0 = CInt(CSng(AD0 - Zero / 4) * Kfactor * 200.0 + 0.5)
                    AD1 = CInt(CSng(AD1 - Zero / 4) * Kfactor * 200.0 + 0.5)

            End Select

            If AD0 > 100 Then AD0 = 100
            If AD0 < -100 Then AD0 = -100
            If AD1 > 100 Then AD1 = 100
            If AD1 < -100 Then AD1 = -100

            gD.DrawLine(Pens.Red, kAD, 200 - 2 * AD0, iAD, 200 - 2 * AD1)
            TextBoxLevel.Text = CStr(CSng(AD1) * Vscale / 100)
            If MaxF > 0 Then
                If MaxPoint < AD1 Then
                    MaxPoint = AD1
                    gD.DrawLine(Pens.Green, 0, 200 - 2 * MaxPoint, 500, 200 - 2 * MaxPoint)
                End If
                If MinPoint > AD1 Then
                    MinPoint = AD1
                    gD.DrawLine(Pens.Green, 0, 200 - 2 * MinPoint, 500, 200 - 2 * MinPoint)
                End If
            End If
        End If

        iAD = iAD + TpointInc
        If TpointInc = 0 Then iAD = iAD + 1

        If iAD > 500 Then '-----1画面終了処理

            AccAD = 0
            AccCntB = AccCnt
            iAD = 0
            Triggered = 0
            If ComboBoxMode.Text = "One Shot" Then
                Pause()
                Measure = 0
                SaveData()
                ReRun(CurrentF) '---イメージ再描画　最小化などで画面が消されるものへの対策　
                GoTo Abort2
            End If

        End If
        GoTo Repeat

Abort1:
        Timer1.Enabled = Enabled
Abort2:
        gD.Dispose()

    End Sub

    Private Sub SaveData()
        '----ファイルセーブ　　デスクトップ　Data_Ocillo.csv 
        '日時,V単位（V）,時間軸設定、Aux時間設定、時間単位(mSec），データ個数,*,*,----データ

        Dim na As String
        If DataFile = "" Then
            na = Application.UserAppDataPath + "\ssrOS1."
        Else
            na = CStr(DataNoB)
            If DataNoB < 10 Then na = "0" + CStr(DataNoB)
            na = DataFile + "_" + na + ".csv"
            DataNoB = DataNoB + 1
            If DataNo = "" Then DataNo = "1"
            If DataNoB = CInt(DataNo) Then DataNoB = 0
        End If
        CurrentF = na
        Dim dd As Date = Date.Now
        Dim d As String = dd.ToString("g")
        Dim v As String = CStr(Vscale / 100)
        Dim Ts As String = ComboBoxTscale.Text
        Dim Tb As String = TextBoxTime.Text
        Dim t As String = CStr(Tunit)
        Dim N As String = "500"
        Dim Vdata As Integer
        If TpointInc > 0 Then N = CStr(500 / TpointInc)

        Try
            Using F_Oci = New IO.StreamWriter(na, False, System.Text.Encoding.Default)
                F_Oci.WriteLine(d)
                F_Oci.WriteLine(v)
                F_Oci.WriteLine(Ts)
                F_Oci.WriteLine(Tb)
                F_Oci.WriteLine(t)
                F_Oci.WriteLine(N)
                Dim k As Integer = 0

                While k < 500
                    Vdata = AD(k)
                    Select Case Vshift
                        Case "4"
                            Vdata = CInt(CSng(Vdata + 384 - Zero) * Kfactor * 200.0 + 0.5)
                        Case "2"
                            Vdata = CInt(CSng(Vdata + 128 - Zero / 2) * Kfactor * 200.0 + 0.5)
                        Case "1"
                            Vdata = CInt(CSng(Vdata - Zero / 4) * Kfactor * 200.0 + 0.5)
                    End Select

                    F_Oci.WriteLine(CStr(Vdata))
                    k = k + TpointInc
                    If TpointInc = 0 Then k = k + 1
                End While
            End Using
        Catch ex As Exception
            ToolTip1.Show(ex.Message, Me, 100, 44, 300000)
        End Try
        TextBox1.Text = "Saved as " + na
    End Sub
    Private Sub ReRun(ByVal f As String)
        Dim AD0 As Integer
        Dim AD1 As Integer

        Dim imgPath As String = Application.UserAppDataPath + "Dimage.bmp"

        If My.Computer.FileSystem.FileExists(imgPath) Then
        Else

            Dim bmp As New Bitmap(1, 1)
            bmp.Save(imgPath, System.Drawing.Imaging.ImageFormat.Bmp)
        End If

        Dim img As System.Drawing.Image = System.Drawing.Image.FromFile(imgPath)


        PictureBoxD.Image = img

        Dim gD As Graphics

        PictureBoxD.Image = New Bitmap(PictureBoxD.ClientRectangle.Width, PictureBoxD.ClientRectangle.Height)

        gD = Graphics.FromImage(PictureBoxD.Image)

        ScaleDraw2()
        Try
            Using F_Oci = New IO.StreamReader(f, System.Text.Encoding.Default)

                Dim d As String = F_Oci.ReadLine()
                ComboBoxRange.Text = CStr(CSng(F_Oci.ReadLine()) * 100)
                ComboBoxTscale.Text = F_Oci.ReadLine()
                TextBoxTime.Text = F_Oci.ReadLine()
                Dim t As String = F_Oci.ReadLine()
                Dim N As String = F_Oci.ReadLine()
                Dim st As Integer = 500 / CInt(N)
                Dim i As Integer = 0
                While i < 500
                    AD1 = CInt(F_Oci.ReadLine())
                    If i > 0 Then gD.DrawLine(Pens.Red, i - st, 200 - 2 * AD0, i, 200 - 2 * AD1)
                    i = i + st
                    AD0 = AD1
                End While
            End Using
        Catch ex As Exception
            ToolTip1.Show(ex.Message, Me, 100, 44, 300000)
        End Try

        gD.Dispose()

    End Sub



    Private Sub ComboBoxMode_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxMode.SelectedIndexChanged

        If ComboBoxMode.Text = "ReRun" Then

            If DataDir = "" Then DataDir = Application.UserAppDataPath
            Dim ofd As New OpenFileDialog()
            ofd.FileName = ""
            ofd.InitialDirectory = DataDir
            ofd.Filter = "全てのファイル(*.*)|*.*|CSVファイル(*.csv)|*.csv"
            ofd.FilterIndex = 2
            ofd.Title = "開くファイルを選択してください"

            If ofd.ShowDialog() = DialogResult.OK Then

                DataDir = ofd.FileName
                ReRun(DataDir)
            End If
            ComboBoxMode.Text = "One Shot"
        End If

    End Sub

    Private Sub TimeSet()


        '　　   　　Tscale　　       　サンプリング周期　　　画面

        '　時間軸（)　T1　　　0.5mS/div　　　0.025mS　　　 １００ポイント+1
        '   　        T2        1mS     　　 0.03mS　　　　１６６
        '             T3        5    　 　　 0.1mS　　　　 ２５０　　　　
        '             T4       10       　   0.2mS　　　 　２５０
        '　　　　　　 T5　　　 50  　　 　　 1mS　　　　 　２５０
        '             T6      100            2mS 　　　　　２５０
        '             T7      500           10mS  　　　　 ２５０　--ここからADunitはリアルタイム送信       　　
        '　　　　 　　T8　　 1000           10mS   　      ５００ポイント/画面
        '　　　　　　 T9　　 <<Sec          10mS      Sec倍でT軸をひとつ進める
        '   
        TpointInc = 2
        AccCnt = 0

        Select Case ComboBoxTscale.Text
            Case "0.5"
                Tscale = "1"
                TpointInc = 5
                Tunit = 0.025  '--格納データの１ポイントの時間単位　ｍS
            Case "1"
                Tscale = "2"
                TpointInc = 3
                Tunit = 0.03
            Case "5"
                Tscale = "3"
                Tunit = 0.1
            Case "10"
                Tscale = "4"
                Tunit = 0.2
            Case "50"
                Tscale = "5"
                Tunit = 1
            Case "100"
                Tscale = "6"
                Tunit = 2
            Case "500"
                Tscale = "7"
                Tunit = 10
            Case "1000"
                Tscale = "7"
                TpointInc = 1
                Tunit = 10
            Case "<<Sec"
                Tscale = "7"
                If TextBoxTime.Text = "" Then TextBoxTime.Text = "1"
                TextBoxTime.Text = CStr(CInt(TextBoxTime.Text))
                AccCnt = CInt(TextBoxTime.Text)
                TpointInc = 0
                Tunit = CSng(TextBoxTime.Text) * 10

        End Select

    End Sub

    Private Sub ComboBoxTscale_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxTscale.SelectedIndexChanged
        If ComboBoxTscale.Text <> "<<Sec" Then
            TextBoxTime.Text = ""
            If Measure = 1 Then
                Pause()
                Start()
            End If
        Else
            If TextBoxTime.Text <> "" And Measure = 1 Then
                Pause()
                Start()
            End If

        End If
    End Sub

    Private Sub TextBoxTime_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxTime.TextChanged
        Try
            Dim a As Integer = CInt(TextBoxTime.Text)
        Catch
            TextBoxTime.Text = ""
        End Try
        If TextBoxTime.Text <> "" Then
            TimeSet()
            If Tscale > 6 And Measure = 1 Then
                Pause()
                Start()
            End If
        End If
    End Sub

    Private Sub Command(ByVal a As String)  'aは2文字　　　エコーバックを待つ
        Dim c1(1) As Char
        Dim c2(1) As Char
        Dim c3(1) As Char

        SerialPort.Write(Mid(a, 1, 1))
        While SerialPort.BytesToRead < 1
        End While
        SerialPort.Read(c1, 0, 1)

        SerialPort.Write(Mid(a, 2, 1))
        While SerialPort.BytesToRead < 1
        End While
        SerialPort.Read(c2, 0, 1)

        SerialPort.Write(ControlChars.Lf)
        While SerialPort.BytesToRead < 1
        End While
        SerialPort.Read(c3, 0, 1)
        RdChr(0) = c1(0)
        RdChr(1) = c2(0)
    End Sub

    Private Sub ScaleDraw() ' 目盛直接描画


        Dim gD As Graphics = PictureBoxD.CreateGraphics()

        gD.FillRectangle(Brushes.Ivory, 0, 0, 500, 400)

        Dim p As New Pen(Color.Blue, 1)
        For x = 0 To 5
            gD.DrawLine(p, x * 100, 0, x * 100, 400)
        Next x
        For y = 0 To 4
            gD.DrawLine(p, 0, y * 100, 500, y * 100)
        Next y
        If MaxF > 0 Then
            If MaxPoint > -100 Then gD.DrawLine(Pens.Green, 0, 200 - 2 * MaxPoint, 500, 200 - 2 * MaxPoint)
            If MinPoint < 100 Then gD.DrawLine(Pens.Green, 0, 200 - 2 * MinPoint, 500, 200 - 2 * MinPoint)
        End If

        gD.Dispose()

    End Sub

    Private Sub ScaleDraw2() ' 目盛イメージ描画　イメージファイルは別途設定
        Dim gD As Graphics
        gD = Graphics.FromImage(PictureBoxD.Image)
        gD.FillRectangle(Brushes.Ivory, 0, 0, 500, 400)


        Dim p As New Pen(Color.Blue, 1)
        For x = 0 To 5
            gD.DrawLine(p, x * 100, 0, x * 100, 400)
        Next x
        For y = 0 To 4
            gD.DrawLine(p, 0, y * 100, 500, y * 100)
        Next y
        If MaxF > 0 Then
            If MaxPoint > -100 Then gD.DrawLine(Pens.Green, 0, 200 - 2 * MaxPoint, 500, 200 - 2 * MaxPoint)
            If MinPoint < 100 Then gD.DrawLine(Pens.Green, 0, 200 - 2 * MinPoint, 500, 200 - 2 * MinPoint)
        End If

    End Sub
    Private Sub ScaleDraw3() ' 目盛イメージ描画　

        Dim imgPath As String = Application.UserAppDataPath + "Dimage.bmp"

        If My.Computer.FileSystem.FileExists(imgPath) Then
        Else

            Dim bmp As New Bitmap(1, 1)
            bmp.Save(imgPath, System.Drawing.Imaging.ImageFormat.Bmp)
        End If

        Dim img As System.Drawing.Image = System.Drawing.Image.FromFile(imgPath)


        PictureBoxD.Image = img

        Dim gD As Graphics

        PictureBoxD.Image = New Bitmap(PictureBoxD.ClientRectangle.Width, PictureBoxD.ClientRectangle.Height)

        gD = Graphics.FromImage(PictureBoxD.Image)

        ScaleDraw2()
        gD.Dispose()

    End Sub

    Private Sub PictureBoxD_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBoxD.Click
        Dim p As Point = PointToClient(System.Windows.Forms.Cursor.Position)
        Dim g As Graphics = PictureBoxD.CreateGraphics()

        Dim x As Integer = p.X
        x = x - 106

        Dim y As Integer = p.Y
        y = y - 144

        Dim V As Single = (200 - CSng(y)) / 200 * Vscale

        Dim DspXY As String = " " & CStr(V) & "V"
        'フォントオブジェクトの作成
        Dim fnt As New Font("MS UI Gothic", 10)
        '文字列を位置(x,y)、緑色で表示
        g.DrawString(DspXY, fnt, Brushes.Green, x, y)
        g.DrawLine(Pens.Green, x - 2, y, x + 2, y)
        'リソースを開放する
        fnt.Dispose()
        g.Dispose()

    End Sub

    Private Sub ButtonMax_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMax.Click
        MaxPoint = -100
        MinPoint = 100
        If MaxF = 1 Then
            MaxF = 0
            ButtonMax.Text = "Set"
        Else
            ButtonMax.Text = "Clear"
            MaxF = 1
        End If

    End Sub

    Private Sub ComboBoxTrigger_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxTrigger.SelectedIndexChanged
        If Measure = 1 Then
            Pause()
            Start()
        End If
    End Sub

    Private Sub CheckBoxEXT_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxEXT.CheckedChanged
        If Measure = 1 Then
            Pause()
            Start()
        End If
    End Sub

    Private Sub RadioButtonUp_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonUp.CheckedChanged

    End Sub

    Private Sub RadioButtonDown_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonDown.CheckedChanged

    End Sub

    Private Sub TextBoxLevel_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxLevel.TextChanged

    End Sub

    Private Sub ComboBoxRange_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxRange.SelectedIndexChanged

        Vscale = CSng(ComboBoxRange.Text)

        If Measure = 1 Then
            Pause()
            Start()
        End If

    End Sub


    Private Sub SystemEvents_PowerModeChanged(ByVal sender As Object, ByVal e As Microsoft.Win32.PowerModeChangedEventArgs)

        If e.Mode = Microsoft.Win32.PowerModes.Suspend And Measure = 1 Then
            Pause()
            Measure = 0
        End If
    End Sub


    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        If MsgBox("Save Setting ?", 1) = 1 Then
            Dim SetPara As String = Application.UserAppDataPath + "Set_Ocillo.ini"
            Try
                Using F_Oci = New IO.StreamWriter(SetPara, False, System.Text.Encoding.Default)

                    F_Oci.WriteLine(ComboBoxPort.Text)
                    F_Oci.WriteLine(ComboBoxMode.Text)
                    F_Oci.WriteLine(ComboBoxTscale.Text)
                    F_Oci.WriteLine(TextBoxTime.Text)
                    F_Oci.WriteLine(RadioButtonUp.Checked)
                    F_Oci.WriteLine(RadioButtonDown.Checked)
                    F_Oci.WriteLine(ComboBoxTrigger.Text)
                    F_Oci.WriteLine(CheckBoxEXT.Checked)
                    F_Oci.WriteLine(ComboBoxRange.Text)
                    F_Oci.WriteLine(DataDir)
                    F_Oci.WriteLine(DataFile)
                    F_Oci.WriteLine(DataNo)
                    F_Oci.WriteLine(ZeroR0)
                    F_Oci.WriteLine(ZeroR1)
                    F_Oci.WriteLine(ZeroR2)
                    F_Oci.WriteLine(Vref)
                End Using
            Catch ex As Exception
                ToolTip1.Show(ex.Message, Me, 100, 44, 300000)

            End Try
        End If
    End Sub

    Private Sub TextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox1.TextChanged

    End Sub

    Private Sub DataFolderToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DataFolderToolStripMenuItem.Click

        ' 連続ファイル名　　***_##.csv　　##=00～99

        DataNo = InputBox("How many files for data ?")
        If DataNo <> "" Then


            If DataNo = "0" Then DataNo = "1"
            If CInt(DataNo) > 100 Then DataNo = "100"
            DataNoB = 0
            If DataDir = "" Then DataDir = Application.UserAppDataPath
            Dim ofd As New OpenFileDialog()
            ofd.FileName = ""
            ofd.InitialDirectory = DataDir
            ofd.Filter = "全てのファイル(*.*)|*.*|CSVファイル(*.csv)|*.csv"
            ofd.FilterIndex = 2
            ofd.Title = "格納するファイル名を設定してください"
            ofd.CheckFileExists = False
            If ofd.ShowDialog() = DialogResult.OK Then
                DataFile = Microsoft.VisualBasic.Left(ofd.FileName, Len(ofd.FileName) - 4)
                DataDir = ofd.FileName
            Else
                DataNo = ""
            End If
        End If

    End Sub

    Private Sub ZeroToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ZeroToolStripMenuItem.Click
        If Measure = 0 Then
            SerialPort.PortName = ComboBoxPort.Text
            SerialPort.DtrEnable = True
            SerialPort.RtsEnable = True
            SerialPort.Open()
            If MsgBox("Short-circuit Input.  Ready ?", 1) = 1 Then
                ZeroR0 = GetVin("R0")
                ZeroR1 = GetVin("R1")
                ZeroR2 = GetVin("R2")
            End If
            SerialPort.Close()
            TextBox1.Text = "Zero=" + CStr(CInt(ZeroR0) - 512)
        End If
    End Sub
    Private Function GetVin(ByVal Range As String) As String  '  電圧値取得　４回平均　ゼロ点バイアスはそのまま
        Command(Range)
        Dim a As Integer = 0
        For i = 1 To 4
            Command("QQ")
            Do While SerialPort.BytesToRead < 2
            Loop
            SerialPort.Read(RdChr, 0, 2)
            Dim b As Integer = RecNum()
            Do While SerialPort.BytesToRead < 3
            Loop
            SerialPort.Read(RdChr, 0, 3)
            b = (b * 4 + RecNum() / 64)
            a = a + b
        Next i
        a = a / 4
        Return CStr(a)

    End Function



    Private Sub Reference185VToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Reference185VToolStripMenuItem.Click
        If Measure = 0 Then
            SerialPort.PortName = ComboBoxPort.Text
            SerialPort.DtrEnable = True
            SerialPort.RtsEnable = True
            SerialPort.Open()
            If MsgBox("Input Standard Voltage.  Ready ?", 1) = 1 Then
                Vref = GetVin("R1")
                TextBox1.Text = "Vref=" + CStr(CInt(Vref) - 512)
            End If

            SerialPort.Close()
            Vscale = CSng(ComboBoxRange.Text)
        End If
    End Sub


    Private Sub VersionToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles VersionToolStripMenuItem.Click
        SerialPort.PortName = ComboBoxPort.Text
        SerialPort.DtrEnable = True
        SerialPort.RtsEnable = True
        SerialPort.Open()
        Command("MM")

        MsgBox("（株）島津総合科学研究所" + ControlChars.Lf + "ssrOS1 System version = " + Version + ControlChars.Lf + _
               "ADunit Version = " + SerialPort.ReadLine)

        SerialPort.Close()

    End Sub

    Private Sub OperatioManualToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OperatioManualToolStripMenuItem.Click


        Dim d As String = "http://www.shimadzu.co.jp/ssr/etc/ssrOsc/help.pdf"

        Help.ShowHelp(TextBox1, d)

    End Sub

    Private Sub ADunitCheckToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ADunitCheckToolStripMenuItem.Click
        Dim a As String
        Dim b As String
        SerialPort.PortName = ComboBoxPort.Text
        SerialPort.DtrEnable = True
        SerialPort.RtsEnable = True
        SerialPort.Open()

Repeat:
        a = InputBox("Input Command ")
        If a <> "" Then
            Command(a)
            b = a + " / " + RdChr(0) + RdChr(1)
            If a = "QQ" Or a = "MM" Then b = b + " / " + SerialPort.ReadLine

            TextBox1.Text = b
            GoTo Repeat
        End If
        SerialPort.Close()
    End Sub

    Private Sub PortToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PortToolStripMenuItem1.Click
        ComboBoxPort.Items.Clear()

        For Each sp As String In My.Computer.Ports.SerialPortNames
            ComboBoxPort.Items.Add(sp)
            ComboBoxPort.Text = sp
        Next

    End Sub

    Private Sub ComboBoxPort_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxPort.SelectedIndexChanged

    End Sub

End Class



